(function(){
	var folder = Folder.selectDialog("フォルダを選択してください");
	if (!folder){ return; }
	var saveUnit = preferences.rulerUnits;
	preferences.rulerUnits = Units.PIXELS;
	var fileList = folder.getFiles("*.jpg");	// JPEGのみ処理
	var count = 0;	// 参照するファイルの位置を示す
	// JPEG保存オプション
	var jpegOpt = new JPEGSaveOptions();
	jpegOpt.embedColorProfile = true;
	jpegOpt.quality = 6;
	jpegOpt.formatOptions = FormatOptions.PROGRESSIVE;
	jpegOpt.scans = 3;
	jpegOpt.matte = MatteType.NONE;
	// ファイル名に付ける末尾の番号
	var fileNo = 1;
	// 全てのファイルを処理するまで繰り返す
	while(true){
		// 新規にドキュメントを作成
		var docObj = documents.add(640, 640);
		// 保存するファイル名を作成
		var savefile = new File(folder.fullName+"/"+fileNo+".jpg");
		fileNo = fileNo + 1;
		for(var y=0; y<10; y++){
			for(var x=0; x<10; x++){
				app.open(fileList[count]);
				app.activeDocument.resizeCanvas(3648+30, 3648+30, AnchorPosition.MIDDLECENTER);
				app.activeDocument.resizeImage(64, 64);	// 64x64サイズに画像を縮小
				app.activeDocument.selection.selectAll();	// 全てを選択
				app.activeDocument.selection.copy();	// コピー
				app.activeDocument.close(SaveOptions.DONOTSAVECHANGES);
				var selReg = [	[x*64, y*64],
										[x*64+64, y*64],
										[x*64+64, y*64+64],
										[x*64, y*64+64],
										[x*64, y*64]];
				docObj.selection.select(selReg);
				docObj.paste(true);
				docObj.selection.deselect();
				docObj.flatten();
				count++;
				if (count >= fileList.length){
					activeDocument.saveAs(savefile, jpegOpt, true, Extension.LOWERCASE);
					activeDocument.close(SaveOptions.DONOTSAVECHANGES);
					preferences.rulerUnits = saveUnit;
					return;
				}
			}
		}
		activeDocument.saveAs(savefile, jpegOpt, true, Extension.LOWERCASE);
		activeDocument.close(SaveOptions.DONOTSAVECHANGES);
	}
	preferences.rulerUnits = saveUnit;
})();
